#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

#include "head.h"

extern int n,t,presentt,literals,s_literals,
  *nv,*p_nv,*n_nv,*s_nv,*ps_nv,*ns_nv,*clause,**pclause,
  *rsell,*rlit;

void init_1()
{
   n=0;
   literals=0;
   s_literals=0;
   t=0;
   presentt=0;
}

void keep_area1()
{
   if((nv=(int *)malloc(sizeof(int)*n*2))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
   if((s_nv=(int *)malloc(sizeof(int)*n*2))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
}

void set_p1()
{
   p_nv=nv;
   n_nv=nv+n;
   ps_nv=s_nv;
   ns_nv=s_nv+n;
}

void init_2()
{
   copy_dat(nv,s_nv,2*n);
   s_literals=literals;
}

void keep_area2()
{
  if((clause=(int *)malloc(sizeof(int)*(2*n+1)*t))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((pclause=(int **)malloc(sizeof(int *)*t))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((rsell=(int *)malloc(sizeof(int)*(n+1)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((rlit=(int *)malloc(sizeof(int)*(2*n+1)))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
}

void set_p2()
{
   int i;

   for(i=0; i<t; i++)
     {
	*(pclause+i)=clause+(2*n+1)*i;
     }
}

void init_3()
{
   int i;

   for(i=0; i<t; i++)
     fill_dat(*(pclause+i),(2*n+1),0);
   fill_dat(rsell,n+1,0);
   fill_dat(rlit,2*n+1,0);
}

int chg_num(chp)
     char *chp;
{
   char *p;

   p = chp;
   while(*p != NULL)
     {
	if(isdigit((int)(*p))==0)
	  {
	     perror("Argument isn't reasonable\n");
	     exit(-1);
	  }
	p+=1;
     }

   return atoi(chp);
}

int num_rand(x,y)
     int x,y;
{
   struct timeb tmptm;
   int i,loopmax,j,k;
   int patern;

   patern=0;
#ifdef DEBUG
   printf("x= %d y=%d\n",x,y);
#endif
   if(y == 0)
        patern=1;
   if ((y<=x)&&(patern==0))
     {
        printf("Function num_rand's arguments is bad!\n");
        exit(-1);
     }
   ftime(&tmptm);
   loopmax = (int) tmptm.millitm;
   for(i=0; i<loopmax; i++) random();
   if(patern==1)
     {
#ifdef DEBUG
	printf("patern =1\n");
#endif
        j=(int)(random()+x);
     }
   else
     {
        k = y-x;
        j = (random() % k) + x;
     }
   return j;
}

void copy_dat(p1,p2,length)
     int *p1,*p2,length;
{
   int i;
   
   for(i=0; i<length; i++)
     {
        *(p2+i)=*(p1+i);
     }
}

void fill_dat(pointer,length,patern)
     int *pointer,length,patern;
{
   int i;
   
   for(i=0; i<length; i++)
     {
	if(patern==0)
	  *(pointer+i)=0;
	else
	  *(pointer+i)=i;
     }
}

void display_dat(pointer,length)
     int *pointer,length;
{
   int i,j;
   
   j=0;
   for(i=0; i<length; i++)
     {
        printf("   %d: %d",(i+1),*(pointer+i));
        j+=1;
        if(j==n)
          {
             printf("\n");
             j=0;
          }
     }
   printf("\n");
}

void removel(pointer,position,datl,length)
     int *pointer,position,datl,length;
{
   int i;

   for(i=position; i<(datl-1); i++)
     {
	*(pointer+i)=*(pointer+i+1);
     }
   *(pointer+i)=0;
/*   *(pointer+datl-1)=0;*/
   *(pointer+length)-=1;
}

int sel_chg_lit(copn)
     int *copn;
{
   int colit;

   do
     {
        printf("Which literal do you change?   ");
        scanf("%d",&colit);
     }while((colit<=0)||(colit>n));
   printf("N[%d]= %d   N[%d']= %d\n",
          colit,*(p_nv+colit-1),colit,*(n_nv+colit-1));
   do
     {
        printf("Which do you change?\n");
        printf("   (0) N[%d ]\n",colit);
        printf("   (1) N[%d']\n",colit);
        printf("   (2) Both\n");
	printf("Select[ 0 - 2 ]:   ");
        scanf("%d",copn);
     }while((*copn<0)||(*copn>2));
   return colit-1;
}

void chg_nv(pn,ttt,litn)
     int pn,ttt,litn;
{
   int tmp0,tmp1,newnum,s,i;

   i=0;
   s=ttt;
   do
     {
        printf("Increase %d or Decrease %d is reasonable\n",XSAT-s,s);
        if(pn != 2)
          {
             if(pn==0)
               {
                  if(i==0)
                    literals -= *(p_nv+litn);
                  printf("N[%d]= %d\n",litn+1,*(p_nv+litn));
		  do
		    {
		       printf("Modify N[%d]   ",litn+1);
		       scanf("%d",&tmp0);
		    }while((tmp0<MIN_NUM_LIT)||(tmp0>MAX_NUM_LIT));
                  *(p_nv+litn)=tmp0;
               }
             else
               {
                  if(i==0)
                    literals -= *(n_nv+litn);
                  printf("N[%d']= %d\n",litn+1,*(n_nv+litn));
		  do
		    {
		       printf("Modify N[%d']   ",litn+1);
		       scanf("%d",&tmp0);
		    }while((tmp0<MIN_NUM_LIT)||(tmp0>MAX_NUM_LIT));
                  *(n_nv+litn)=tmp0;
               }
             newnum = literals + tmp0;
          }
        else
          {
             if(i==0)
               literals -= (*(p_nv+litn)+ (*(n_nv+litn)));
             printf("N[%d]= %d  N[%d']= %d\n",
                    litn+1,*(p_nv+litn),litn+1,*(n_nv+litn));
	     do
	       {
		  printf("Modify N[%d ]   ",litn+1);
		  scanf("%d",&tmp0);
	       }while((tmp0<MIN_NUM_LIT)||(tmp0>MAX_NUM_LIT));
	     do
	       {
		  printf("Modify N[%d']   ",litn+1);
		  scanf("%d",&tmp1);
	       }while((tmp1<MIN_NUM_LIT)||(tmp1>MAX_NUM_LIT));
             newnum = literals + tmp0 + tmp1;
             *(p_nv+litn)=tmp0;
             *(n_nv+litn)=tmp1;
          }
        s=newnum%3;
        i++;
     }while(s);
   literals = newnum;
   t = literals/XSAT;
}


void rand_chg_nv(tt)
     int tt;
{
   int colit,porn;

   colit=num_rand(0,n);
   porn=num_rand(0,2);
   if(porn)
     *(p_nv+colit)+= XSAT-tt;
   else
     *(n_nv+colit)+= XSAT-tt;
   literals += 3-tt;
   t=literals/XSAT;
}

void in_num_lit()
{
   int i,tmp,mods,cow,co,lit;

   for(i=0; i<n; i++)
     {
        do
          {
             printf("N[%d ]= ",i+1);
             scanf("%d",&tmp);
          }while((tmp<MIN_NUM_LIT)||(tmp>MAX_NUM_LIT));
        *(p_nv+i) = tmp;
        literals += tmp;
        do
          {
             printf("N[%d']= ",i+1);
             scanf("%d",&tmp);
          }while((tmp<MIN_NUM_LIT)||(tmp>MAX_LIT));
        *(n_nv+i) = tmp;
        literals += tmp;
        printf("\n");
     }
   printf("Total of Literals = %d\n",literals);
   if(((mods = literals%XSAT) == 0)&&(literals != 0))
     {
        t = literals/XSAT;
     }
   else
     {
        printf("Warnig: The total of literals must be multiple of %d\n",XSAT);
        printf("Modification\n");
        do
          {
             printf("   (0) Modify yourself \n");
             printf("   (1) Modify at random\n");
             printf("Select[ 0 - 1 ]:   ");
	     scanf("%d",&cow);
          }while((cow<0)||(cow>1));
        if(cow==0)
          {
             lit = sel_chg_lit(&co);
             chg_nv(co,mods,lit);
          }
        else
          rand_chg_nv(mods);
     }
}

void rmake_dat(pointer,length,minnum,maxnum,makenv)
     int *pointer,length,minnum,maxnum,makenv;
{
   int i,tmp,mods;

   for(i=0; i<length; i++)
     {
        tmp = num_rand(minnum,maxnum);
        *(pointer+i)=tmp;
        if(makenv)
          literals += tmp;
     }
   if(makenv)
     {
        if(mods=(literals%XSAT))
          rand_chg_nv(mods);
        else
          {
             t=literals/XSAT;
          }
     }
   else
     {
     }
   printf("\n");
}

void in_same_dat()
{
   int samenum,i,mods;

   do
     {
	printf("Literal occurrence number ?  ");
	scanf("%d",&samenum);
     }while((samenum<=MIN_NUM_LIT)||(samenum>MAX_NUM_LIT));
   for(i=0; i<2*n; i++)
     {
	*(nv+i)=samenum;
	literals+=*(nv+i);
     }
   if(mods=(literals%XSAT))
     rand_chg_nv(mods);
   else
     {
	t=literals/XSAT;
     }
}   

void seiki_bunpu()
{
   int numc,m,allit,lit,i,j,val,pos,tmp,fin;
   int *rl;

   lit=0;
   do
     {
	printf("Average number ?  ");
	scanf("%d",&m);
	allit=m*n*2;
     }while(allit%XSAT);
   numc=allit/XSAT;
   for(i=0; i<(2*n); i++)
     {
	val=0;
	for(j=0; j<numc; j++)
	  {
	     if(num_rand(0,2*n)<XSAT)
	       {
		  val+=1;
	       }
	  }
	*(nv+i)=val;
	lit+=val;
     }
   if((rl=(int *)malloc(sizeof(int)*(n+1)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
   if(lit!=allit)
     {
	if(lit<allit)
	  {
	     for(i=0; i<(allit-lit); i++)
	       {
		  pos=num_rand(0,2*n);
		  *(nv+pos)+=1;
	       }
	  }
	else
	  {
	     fill_dat(rl,n+1,1);
	     for(i=0; i<(lit-allit); i++)
	       {
		  fin=0;
		  do
		    {
		       tmp=num_rand(0,*(rl+n));
		       pos=*(rl+tmp);
		       if(*(nv+pos)>0)
			 {
			    *(nv+pos)-=1;
			    fin=1;
			 }
		       else
			 {
			    removel(rl,tmp,*(rl+n),n+1);
			 }
		    }while(fin==0);
	       }
	  }
     }
   literals=allit;
   t=numc;
}

void ratio_in()
{
   float rate;
   int lnum,more,i,incl;

   printf("Input the ratio(Clause/Variable)  ");
   scanf("%f",&rate);
   t=(int)(n*rate);
   literals=3*t;
   lnum=literals/(n*2);
   more=literals%(n*2);
#ifdef DEBUG
   printf("t= %d literals= %d lnum= %d more= %d\n",
	  t,literals,lnum,more);
#endif
   for(i=0; i<2*n; i++)
     {
	*(nv+i)=lnum;
     }
   for(i=0; i<more; i++)
     {
	incl=num_rand(0,2*n);
	*(nv+incl)+=1;
     }
#ifdef DEBUG
   for(i=0; i<n; i++)
     {
	printf("nv[%d]= %d  nv[%d']= %d \n",i,*(nv+i),i,*(nv+n+i));
     }
#endif 
/*   exit(0);*/
}

void out_lit()
{
   int i;

   printf("\n");
   printf("@@@@@@@@@@@  OUTPUT  @@@@@@@@@@@\n\n");
   printf("###   Literal Distribution  ###\n\n");
   for(i=0; i<n; i++)
     {
	printf("N[%2d]= %d    N[%2d']= %d\n",
	       i+1,*(ps_nv+i),i+1,*(ns_nv+i));
     }
   printf("\n");
   printf("Total of literals      :: %d\n",s_literals);
   printf("Number of clauses      :: %d\n\n",t);
}

void out_pred()
{
   int i,j,numc,samelit;

   printf("\n\n");
   printf("###  %dSAT CNF Predicate  ###\n\n",XSAT);
   for(i=0; i<t; i++)
     {
	numc=0;
	printf("(");
	for(j=0; ((j<n)&&(numc<XSAT)); j++)
	  {
	     samelit= *(*(pclause+i)+j);
	     if(samelit > 0)
	       {
		  while(samelit >0)
		    {
		       printf("%d ",j+1);
		       samelit-=1;
		       numc +=1;
		    }
	       }
	     samelit= *(*(pclause+i)+n+j);
	     if(samelit > 0)
	       {
		  while(samelit >0)
		    {
		       printf("%d'",j+1);
		       samelit = samelit-1;
		       numc +=1;
		    }
	       }
	  }
	printf(")");
     }
   printf("\n");
}

/*void dimacs_out()
{
   int i,j,samelit,numlit;

   printf("p cnf %d %d\n",n,t);
   for(i=0; i<t; i++)
     {
	numlit=0;
	for(j=0; ((j<n)&&(numlit<XSAT)); j++)
	  {
	     samelit=0;
	     if((samelit=*(*(pclause+i)+j))>0)
	       {
		  while(samelit>0)
		    {
		       printf("%d ",j+1);
		       samelit-=1;
		       numlit+=1;
		    }
	       }
	     if((samelit=*(*(pclause+i)+n+j))>0)
	       {
		  while(samelit>0)
		    {
		       printf("-%d ",j+1);
		       samelit-=1;
		       numlit+=1;
		    }
	       }
	  }
	printf("0\n");
     }
}*/

void dimacs_out()
{
   int i,j,samelit,numlit;

/*   printf("p cnf %d %d\n",n,t);*/
   printf("%d\n",n);
   printf("%d\n",t);
   printf("%d\n",XSAT);
   printf("141421356\n");
   for(i=0; i<t; i++)
     {
	numlit=0;
	for(j=0; ((j<n)&&(numlit<XSAT)); j++)
	  {
	     samelit=0;
	     if((samelit=*(*(pclause+i)+j))>0)
	       {
		  while(samelit>0)
		    {
		       printf("%d ",j+1);
		       samelit-=1;
		       numlit+=1;
		    }
	       }
	     if((samelit=*(*(pclause+i)+n+j))>0)
	       {
		  while(samelit>0)
		    {
		       printf("-%d ",j+1);
		       samelit-=1;
		       numlit+=1;
		    }
	       }
	  }
	printf("\n");
/*	printf("0\n");*/
     }
}









