#include <stdio.h>
#include <ctype.h>

FILE *inf,*outf;
int n,t,sat,seed,tmp;
int ch,i;

void usage(),getval();

main(argc,argv)
     int argc;
     char **argv;
{
   if(argc!=3)
     {
        usage(argv);
        exit(-1);
     }
   if((inf=fopen(*(argv+1),"r"))==NULL)
     {
        fprintf(stderr,"Cannot open FILE : %s\n",*(argv+1));
        usage(argv);
        exit(-1);
     }
   if((outf=fopen(*(argv+2),"w"))==NULL)
     {
	fprintf(stderr,"Cannot open FILE : %s\n",*(argv+1));
        usage(argv);
        exit(-1);
     }
   getval(&n);
   getval(&t);
   getval(&sat);
   getval(&seed);
   fprintf(outf,"p cnf %d %d\n",n,t);
   ch=fgetc(inf);
   i=0;
   while((feof(inf)==0)&&(i<t))
     {
	fprintf(outf,"%c",ch);
	ch=fgetc(inf);
	if((ch=='\n')&&(feof(inf)==0))
	  {
	     fprintf(outf,"%d",0);
	     i++;
	  }
     }
   fprintf(stderr,"finish\n");
   
   fclose(inf);
   fclose(outf);
}

void usage(argv)
     char **argv;
{
   fprintf(stderr,"usage : %s <Inputfile>\n",*argv);
   exit(-1);
}

void getval(number)
     int *number;
{
   int tmpval,patern;

   patern=0;
   if(feof(inf)!=0)
     {
        fprintf(stderr,"Get value Fail\n");
        exit(-1);
     }
   tmpval=0;
   ch=fgetc(inf);
   if(ch=='-')
     {
        patern=1;
        ch=fgetc(inf);
     }
/*   while((ch!=*lfd)&&(ch!=*sp))*/
   while(isdigit(ch))
     {
        tmpval=tmpval*10;
        tmpval+=ch-'0';
        ch=fgetc(inf);
#ifdef DEBUG
        printf("tmpval= %d",tmpval);
#endif
     }
   if(patern==1)
     *number=-tmpval;
   else
     *number=tmpval;
}
